Index: src/main/java/mk/ukim/finki/busngo/config/WebSecurityConfig.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/config/WebSecurityConfig.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/config/WebSecurityConfig.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -46,5 +46,5 @@
                         .permitAll()
                         .failureUrl("/login?error=BadCredentials")
-                        .defaultSuccessUrl("/", true)
+                        .defaultSuccessUrl("/bilet", true)
                 )
                 .logout((logout) -> logout
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Bilet.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Bilet.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Bilet.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -17,15 +17,19 @@
     @Id
     @Column(name = "b_id")
-    private Long bId;
+    private Long BId;
+
     @Basic
     @Column(name = "b_datum_na_kupuvanje")
     private Timestamp bDatumNaKupuvanje;
+
     @Basic
     @Column(name = "b_status", columnDefinition = "string_kratok")
     @Enumerated(EnumType.STRING)
     private BILET_STATUS bStatus;
+
     @ManyToOne
     @JoinColumn(name = "patnik_k_id", referencedColumnName = "k_id")
-    private Korisnik korisnikByPatnikKId;
+    private Patnik korisnikByPatnikKId;
+
     @ManyToOne
     @JoinColumn(name = "tb_id", referencedColumnName = "tb_id")
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Instancanalinija.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Instancanalinija.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Instancanalinija.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -24,5 +24,5 @@
     @ManyToOne
     @JoinColumn(name = "vozac_k_id", referencedColumnName = "k_id", nullable = false)
-    private Korisnik korisnikByVozacKId;
+    private Vozac korisnikByVozacKId;
     @ManyToOne
     @JoinColumn(name = "a_registracija", referencedColumnName = "a_registracija")
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Kazna.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Kazna.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Kazna.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -9,4 +9,5 @@
 @Data
 @Entity
+@Inheritance(strategy = InheritanceType.JOINED)
 public class Kazna {
     @GeneratedValue(strategy = GenerationType.IDENTITY)
@@ -14,28 +15,37 @@
     @Column(name = "kz_id")
     private Long kzId;
+
     @Basic
     @Column(name = "kz_iznos")
     private Double kzIznos;
+
     @Basic
     @Column(name = "kz_plateno")
     private Boolean kzPlateno;
+
     @Basic
     @Column(name = "kz_datum")
     private Timestamp kzDatum;
+
     @Basic
     @Column(name = "kz_datum_plateno")
     private Timestamp kzDatumPlateno;
+
     @Basic
     @Column(name = "kz_dokument")
     private String kzDokument;
+
     @ManyToOne
     @JoinColumn(name = "kondukter_k_id", referencedColumnName = "k_id")
-    private Korisnik korisnikByKondukterKId;
+    private Kondukter korisnikByKondukterKId;
+
     @ManyToOne
     @JoinColumn(name = "kontrola_id", referencedColumnName = "kontrola_id")
     private Kontroli kontroliByKontrolaId;
-    @OneToOne(mappedBy = "kaznaByKzId")
-    private Kaznazaneregistriran kaznazaneregistriranByKzId;
-    @OneToOne(mappedBy = "kaznaByKzId")
-    private Kaznazaregistriran kaznazaregistriranByKzId;
+
+//    @OneToOne(mappedBy = "kaznaByKzId")
+//    private Kaznazaneregistriran kaznazaneregistriranByKzId;
+//
+//    @OneToOne(mappedBy = "kaznaByKzId")
+//    private Kaznazaregistriran kaznazaregistriranByKzId;
 }
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Kaznazaneregistriran.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Kaznazaneregistriran.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Kaznazaneregistriran.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -8,20 +8,15 @@
 @Data
 @Entity
-public class Kaznazaneregistriran {
-    @GeneratedValue(strategy = GenerationType.IDENTITY)
-    @Id
-    @Column(name = "kz_id")
-    private Long kzId;
+public class Kaznazaneregistriran extends Kazna {
     @Basic
     @Column(name = "kzn_telefon")
     private String kznTelefon;
+
     @Basic
     @Column(name = "kzn_ime")
     private String kznIme;
+
     @Basic
     @Column(name = "kzn_adresa")
     private String kznAdresa;
-    @OneToOne
-    @JoinColumn(name = "kz_id", referencedColumnName = "kz_id", nullable = false)
-    private Kazna kaznaByKzId;
 }
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Kaznazaregistriran.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Kaznazaregistriran.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Kaznazaregistriran.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -8,14 +8,7 @@
 @Data
 @Entity
-public class Kaznazaregistriran {
-    @GeneratedValue(strategy = GenerationType.IDENTITY)
-    @Id
-    @Column(name = "kz_id")
-    private Long kzId;
-    @OneToOne
-    @JoinColumn(name = "kz_id", referencedColumnName = "kz_id", nullable = false)
-    private Kazna kaznaByKzId;
+public class Kaznazaregistriran extends Kazna{
     @ManyToOne
     @JoinColumn(name = "patnik_k_id", referencedColumnName = "k_id")
-    private Korisnik korisnikByPatnikKId;
+    private Patnik korisnikByPatnikKId;
 }
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Kondukter.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Kondukter.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Kondukter.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -4,16 +4,14 @@
 import lombok.Data;
 
+import java.util.List;
 import java.util.Objects;
 
 @Data
 @Entity
-public class Kondukter {
-    @GeneratedValue(strategy = GenerationType.IDENTITY)
-    @Id
-    @Column(name = "k_id")
-    private Long kId;
-    @OneToOne
-    @JoinColumn(name = "k_id", referencedColumnName = "k_id", nullable = false)
-    private Korisnik korisnikByKId;
+public class Kondukter extends Vraboten{
+    @OneToMany(mappedBy = "korisnikByKondukterKId")
+    private List<Kazna> kaznasByKId;
+    @OneToMany(mappedBy = "korisnikByKondukterKId")
+    private List<Kontroli> kontrolisByKId;
 
 }
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Kontroli.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Kontroli.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Kontroli.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -23,5 +23,5 @@
     @ManyToOne
     @JoinColumn(name = "kondukter_k_id", referencedColumnName = "k_id")
-    private Korisnik korisnikByKondukterKId;
+    private Kondukter korisnikByKondukterKId;
     @ManyToOne
     @JoinColumn(name = "inl_id", referencedColumnName = "inl_id")
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Korisnik.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Korisnik.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Korisnik.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -15,4 +15,5 @@
 @Data
 @Entity
+@Inheritance(strategy = InheritanceType.JOINED)
 public class Korisnik implements UserDetails {
     @GeneratedValue(strategy = GenerationType.IDENTITY)
@@ -20,27 +21,35 @@
     @Column(name = "k_id")
     private Long kId;
+
     @Basic
     @Column(name = "k_ime")
     private String kIme;
+
     @Basic
     @Column(name = "k_adresa")
     private String kAdresa;
+
     @Basic
     @Column(name = "k_telefon")
     private String kTelefon;
+
     @Basic
     @Column(name = "k_email")
     private String kEmail;
+
     @Basic
     @Column(name = "k_embg")
     private String kEmbg;
+
     @Basic
     @Column(name = "k_is_admin")
     private Boolean kIsAdmin;
+
     @Basic
     @Column(name = "k_lozinka")
     private String kLozinka;
-    @OneToMany(mappedBy = "korisnikByPatnikKId")
-    private List<Bilet> biletsByKId;
+
+//    @OneToMany(mappedBy = "korisnikByPatnikKId")
+//    private List<Bilet> biletsByKId;
 //    private boolean isAccountNonExpired = true;
 //    private boolean isAccountNonLocked = true;
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Patnik.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Patnik.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Patnik.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -4,15 +4,17 @@
 import lombok.Data;
 
+import java.util.List;
 import java.util.Objects;
 
 @Data
 @Entity
-public class Patnik {
-    @GeneratedValue(strategy = GenerationType.IDENTITY)
-    @Id
-    @Column(name = "k_id")
-    private Long kId;
-    @OneToOne
-    @JoinColumn(name = "k_id", referencedColumnName = "k_id", nullable = false)
-    private Korisnik korisnikByKId;
+public class Patnik extends Korisnik {
+    @OneToMany(mappedBy = "korisnikByPatnikKId")
+    private List<Bilet> biletsByKId;
+
+    @OneToMany(mappedBy = "korisnikByPatnikKId")
+    private List<Kaznazaregistriran> kaznazaregistriransByKId;
+
+    @OneToMany(mappedBy = "korisnikByPatnikKId")
+    private List<Vozenje> vozenjesByKId;
 }
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Tipbilet.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Tipbilet.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Tipbilet.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -19,4 +19,7 @@
     private Long tbTrajnost;
     @Basic
+    @Column(name = "tb_cena")
+    private Float tbCena;
+    @Basic
     @Column(name = "tb_ime")
     private String tbIme;
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Vozac.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Vozac.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Vozac.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -4,16 +4,12 @@
 import lombok.Data;
 
+import java.util.List;
 import java.util.Objects;
 
 @Data
 @Entity
-public class Vozac {
-    @GeneratedValue(strategy = GenerationType.IDENTITY)
-    @Id
-    @Column(name = "k_id")
-    private Long kId;
-    @OneToOne
-    @JoinColumn(name = "k_id", referencedColumnName = "k_id", nullable = false)
-    private Korisnik korisnikByKId;
+public class Vozac extends Vraboten {
+    @OneToMany(mappedBy = "korisnikByVozacKId")
+    private List<Instancanalinija> instancanalinijasByKId;
 
 }
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Vozenje.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Vozenje.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Vozenje.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -27,5 +27,5 @@
     @ManyToOne
     @JoinColumn(name = "patnik_k_id", referencedColumnName = "k_id")
-    private Korisnik korisnikByPatnikKId;
+    private Patnik korisnikByPatnikKId;
     @ManyToOne
     @JoinColumn(name = "kacuva_pnl_id", referencedColumnName = "pnl_id", nullable = false)
Index: src/main/java/mk/ukim/finki/busngo/model/entities/Vraboten.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/entities/Vraboten.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/entities/Vraboten.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -10,21 +10,16 @@
 @Data
 @Entity
-public class Vraboten {
-    @GeneratedValue(strategy = GenerationType.IDENTITY)
-    @Id
-    @Column(name = "k_id")
-    private Long kId;
+public class Vraboten extends Korisnik {
     @Basic
     @Column(name = "v_plata")
     private Double vPlata;
+
     @Basic
     @Column(name = "v_datum_na_vrabotuvanje")
     private Date vDatumNaVrabotuvanje;
+
     @Basic
     @Column(name = "v_datum_prekin_vrabotuvanje")
     private Date vDatumPrekinVrabotuvanje;
-    @OneToOne
-    @JoinColumn(name = "k_id", referencedColumnName = "k_id", nullable = false)
-    private Korisnik korisnikByKId;
 
 }
Index: src/main/java/mk/ukim/finki/busngo/model/enums/Role.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/enums/Role.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/model/enums/Role.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -6,4 +6,7 @@
 public enum Role implements GrantedAuthority {
     ROLE_USER,
+    ROLE_PASSENGER,
+    ROLE_DRIVER,
+    ROLE_CONDUCTOR,
     ROLE_ADMIN;
 
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidAvtobusRegistracijaException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidAvtobusRegistracijaException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidAvtobusRegistracijaException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class InvalidAvtobusRegistracijaException extends RuntimeException{
+    public InvalidAvtobusRegistracijaException() {
+        super("Invalid avtobus registracija!");
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidBiletIdException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidBiletIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidBiletIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class InvalidBiletIdException extends RuntimeException{
+    public InvalidBiletIdException() {
+        super("Invalid bilet id!");
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidInstancaNaLinijaIdException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidInstancaNaLinijaIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidInstancaNaLinijaIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class InvalidInstancaNaLinijaIdException extends RuntimeException{
+    public InvalidInstancaNaLinijaIdException() {
+        super("Invalid instanca na linija id!");
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidLinijaIdException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidLinijaIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidLinijaIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class InvalidLinijaIdException extends RuntimeException{
+    public InvalidLinijaIdException() {
+        super("Invalid linija id!");
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidPostojkaNaLinijaIdException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidPostojkaNaLinijaIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidPostojkaNaLinijaIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class InvalidPostojkaNaLinijaIdException extends RuntimeException {
+    public InvalidPostojkaNaLinijaIdException() {
+        super("Invalid postoja na linija id!");
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidVozacIdException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidVozacIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidVozacIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class InvalidVozacIdException extends RuntimeException{
+    public InvalidVozacIdException() {
+        super("Invalid vozac id!");
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidVozenjeIdException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidVozenjeIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/InvalidVozenjeIdException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class InvalidVozenjeIdException extends RuntimeException{
+    public InvalidVozenjeIdException() {
+        super("Inavlid vozenje id!");
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/model/exceptions/UserShouldNotBeTicketedException.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/model/exceptions/UserShouldNotBeTicketedException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/model/exceptions/UserShouldNotBeTicketedException.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.model.exceptions;
+
+public class UserShouldNotBeTicketedException extends RuntimeException{
+    public UserShouldNotBeTicketedException(String message) {
+        super(message);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/AvtobusRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/AvtobusRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/AvtobusRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,12 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Avtobus;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Query;
+
+import java.util.Optional;
+
+public interface AvtobusRepository extends JpaRepository<Avtobus, Long> {
+    @Query("select a from Avtobus a where a.aRegistracija = ?1")
+    Optional<Avtobus> findByARegistracija(String registracija);
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/BiletRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/BiletRepository.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/repository/BiletRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -8,4 +8,5 @@
 
 import java.util.List;
+import java.util.Optional;
 
 
@@ -13,3 +14,4 @@
 //    List<Bilet> findAllByKorisnikByPatnikKIdAndBStatus(Korisnik korisnik, BILET_STATUS status);
 //    List<Bilet> findAllByKorisnikByPatnikKId(Korisnik korisnik);
+    Optional<Bilet> findByBIdAndAndKorisnikByPatnikKId(Long bid, Patnik patnik);
 }
Index: src/main/java/mk/ukim/finki/busngo/repository/InstancaNaLinijaRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/InstancaNaLinijaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/InstancaNaLinijaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,13 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Instancanalinija;
+import mk.ukim.finki.busngo.model.entities.Linija;
+import mk.ukim.finki.busngo.service.LinijaService;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+import java.util.List;
+
+public interface InstancaNaLinijaRepository extends JpaRepository<Instancanalinija, Long> {
+    List<Instancanalinija> findAllByLinijaByLiIdAndInlDatumEndIsNull(Linija linija);
+    List<Instancanalinija> findAllByInlDatumEndIsNull();
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/KaznaRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/KaznaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/KaznaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,13 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Kazna;
+import mk.ukim.finki.busngo.model.entities.Kontroli;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.repository.NoRepositoryBean;
+
+import java.util.List;
+
+
+public interface KaznaRepository extends JpaRepository<Kazna, Long> {
+    List<Kazna> findAllByKontroliByKontrolaId(Kontroli kontroli);
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/KaznaZaNeregistriranRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/KaznaZaNeregistriranRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/KaznaZaNeregistriranRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Kaznazaneregistriran;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+public interface KaznaZaNeregistriranRepository extends JpaRepository<Kaznazaneregistriran, Long> {
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/KaznaZaRegistriranRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/KaznaZaRegistriranRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/KaznaZaRegistriranRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,11 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Kaznazaregistriran;
+import mk.ukim.finki.busngo.model.entities.Patnik;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+import java.util.List;
+
+public interface KaznaZaRegistriranRepository extends JpaRepository<Kaznazaregistriran, Long> {
+    List<Kaznazaregistriran> findAllByKorisnikByPatnikKId(Patnik patnik);
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/KondukterRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/KondukterRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/KondukterRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,13 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Kondukter;
+import mk.ukim.finki.busngo.model.entities.Patnik;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Query;
+
+import java.util.Optional;
+
+public interface KondukterRepository extends JpaRepository<Kondukter, Long> {
+    @Query("SELECT p from Kondukter p where p.kEmail = ?1")
+    Optional<Kondukter> findByKEmail(String email);
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/KontrolaRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/KontrolaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/KontrolaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,11 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Instancanalinija;
+import mk.ukim.finki.busngo.model.entities.Kontroli;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+import java.util.List;
+
+public interface KontrolaRepository extends JpaRepository<Kontroli, Long> {
+    List<Kontroli> findAllByInstancanalinijaByInlId(Instancanalinija inl);
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/KorisnikRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/KorisnikRepository.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/repository/KorisnikRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -5,6 +5,8 @@
 import org.springframework.data.jpa.repository.JpaRepository;
 import org.springframework.data.jpa.repository.Query;
+import org.springframework.data.repository.NoRepositoryBean;
 
 import java.util.Optional;
+
 
 public interface KorisnikRepository extends JpaRepository<Korisnik, Long> {
Index: src/main/java/mk/ukim/finki/busngo/repository/LinijaRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/LinijaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/LinijaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,7 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Linija;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+public interface LinijaRepository extends JpaRepository<Linija, Long> {
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/PatnikRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/PatnikRepository.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/repository/PatnikRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -3,7 +3,12 @@
 import mk.ukim.finki.busngo.model.entities.Patnik;
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Query;
 import org.springframework.stereotype.Repository;
 
+import java.util.List;
+import java.util.Optional;
+
 public interface PatnikRepository extends JpaRepository<Patnik, Long> {
-
+    @Query("SELECT p from Patnik p where p.kEmail = ?1")
+    Optional<Patnik> findByKEmail(String email);
 }
Index: src/main/java/mk/ukim/finki/busngo/repository/PostojkaNaLinijaRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/PostojkaNaLinijaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/PostojkaNaLinijaRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,14 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Linija;
+import mk.ukim.finki.busngo.model.entities.Postojkanalinija;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.query.Jpa21Utils;
+
+import java.util.List;
+import java.util.Optional;
+
+public interface PostojkaNaLinijaRepository extends JpaRepository<Postojkanalinija, Long> {
+    List<Postojkanalinija> findAllByLinijaByLiId(Linija linija);
+    List<Postojkanalinija> findAllByLinijaByLiIdAndPnlRedenBrojGreaterThan(Linija linija, Short redenBroj);
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/VozacRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/VozacRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/VozacRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,14 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Patnik;
+import mk.ukim.finki.busngo.model.entities.Vozac;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Query;
+
+import java.util.Optional;
+
+public interface VozacRepository extends JpaRepository<Vozac, Long> {
+
+    @Query("SELECT v from Vozac v where v.kEmail = ?1")
+    Optional<Vozac> findByKEmail(String email);
+}
Index: src/main/java/mk/ukim/finki/busngo/repository/VozenjeRepository.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/repository/VozenjeRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/repository/VozenjeRepository.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,11 @@
+package mk.ukim.finki.busngo.repository;
+
+import mk.ukim.finki.busngo.model.entities.Patnik;
+import mk.ukim.finki.busngo.model.entities.Vozenje;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+import java.util.List;
+
+public interface VozenjeRepository extends JpaRepository<Vozenje, Long> {
+    List<Vozenje> findAllByKorisnikByPatnikKId(Patnik patnik);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/AuthService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/AuthService.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/service/AuthService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -5,5 +5,5 @@
 public interface AuthService {
     Korisnik login(String email, String password);
-    Korisnik register(String ime, String email, String password, String confirmPassword, String address, String telefon);
+    Korisnik registerPatnik(String ime, String email, String password, String confirmPassword, String address, String telefon);
 
 }
